package betterwithmods.module.gameplay;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMItems;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.common.registry.bulk.manager.StokedCrucibleManager;
import betterwithmods.module.Feature;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.oredict.OreDictionary;

import static betterwithmods.module.gameplay.CrucibleRecipes.addStokedCrucibleRecipe;

/**
 * Created by tyler on 4/20/17.
 */
public class MetalReclaming extends Feature {
    public static int reclaimCount;

    public static void addReclaimRecipe(ItemStack input, String oreSuffix, int ingotCount) {
        int totalNuggets = ingotCount * reclaimCount;
        int ingots = totalNuggets / 9;
        int nuggets = totalNuggets % 9;
        ItemStack ingotStack = ItemStack.field_190927_a;
        ItemStack nuggetStack = ItemStack.field_190927_a;
        if (ingots > 0 && !OreDictionary.getOres("ingot" + oreSuffix).isEmpty())
            ingotStack = OreDictionary.getOres("ingot" + oreSuffix).get(0);
        if (nuggets > 0 && !OreDictionary.getOres("nugget" + oreSuffix).isEmpty())
            nuggetStack = OreDictionary.getOres("nugget" + oreSuffix).get(0);
        if (ingotStack.func_190926_b()) {
            if (!nuggetStack.func_190926_b()) {
                StokedCrucibleManager.getInstance().addRecipe(new ItemStack(nuggetStack.func_77973_b(), totalNuggets > nuggets ? totalNuggets : nuggets, nuggetStack.func_77960_j()), new Object[]{input.func_77946_l()});
            }
        } else {
            StokedCrucibleManager.getInstance().addRecipe(new ItemStack(ingotStack.func_77973_b(), ingots, ingotStack.func_77960_j()), nuggetStack != null ? new ItemStack(nuggetStack.func_77973_b(), nuggets, nuggetStack.func_77960_j()) : ItemStack.field_190927_a, new Object[]{input.func_77946_l()});
        }
    }

    @Override
    public String getFeatureDescription() {
        return "Adds recipes to the Crucible to melt metal items back into their component metals";
    }

    @Override
    public void setupConfig() {
        reclaimCount = loadPropInt("Reclaming Count", "Amount (in nuggets per ingot) tools and armor in the crucible reclaim. Does not affect diamond or soulforged steel ingot reclamation. (Set to 0 to disable reclamation entirely.)", "", 6, 0, 9);
    }

    @Override
    public void init(FMLInitializationEvent event) {
        if (reclaimCount > 0) {
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 2), new Object[]{new ItemStack(BWMItems.STEEL_HOE, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 2),new Object[]{new ItemStack(BWMItems.STEEL_SWORD, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 3), new Object[]{new ItemStack(BWMItems.STEEL_SWORD, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 3), new Object[]{new ItemStack(BWMItems.STEEL_PICKAXE, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 3), new Object[]{new ItemStack(BWMItems.STEEL_AXE, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL), new Object[]{new ItemStack(BWMItems.STEEL_SHOVEL, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 4), new Object[]{new ItemStack(BWMItems.STEEL_MATTOCK, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 5), new Object[]{new ItemStack(BWMItems.STEEL_BATTLEAXE, 1, OreDictionary.WILDCARD_VALUE)});
            addReclaimRecipe(new ItemStack(Items.field_151030_Z, 1, OreDictionary.WILDCARD_VALUE), "Iron", 8);
            addReclaimRecipe(new ItemStack(Items.field_151036_c, 1, OreDictionary.WILDCARD_VALUE), "Iron", 3);
            addReclaimRecipe(new ItemStack(Items.field_151167_ab, 1, OreDictionary.WILDCARD_VALUE), "Iron", 4);
            addReclaimRecipe(new ItemStack(Items.field_151028_Y, 1, OreDictionary.WILDCARD_VALUE), "Iron", 5);
            addReclaimRecipe(new ItemStack(Items.field_151165_aa, 1, OreDictionary.WILDCARD_VALUE), "Iron", 7);
            addReclaimRecipe(new ItemStack(Items.field_151019_K, 1, OreDictionary.WILDCARD_VALUE), "Iron", 2);
            addReclaimRecipe(new ItemStack(Items.field_151035_b, 1, OreDictionary.WILDCARD_VALUE), "Iron", 3);
            addReclaimRecipe(new ItemStack(Items.field_151037_a, 1, OreDictionary.WILDCARD_VALUE), "Iron", 1);
            addReclaimRecipe(new ItemStack(Items.field_151040_l, 1, OreDictionary.WILDCARD_VALUE), "Iron", 2);
            addReclaimRecipe(new ItemStack(Items.field_151171_ah, 1, OreDictionary.WILDCARD_VALUE), "Gold", 8);
            addReclaimRecipe(new ItemStack(Items.field_151006_E, 1, OreDictionary.WILDCARD_VALUE), "Gold", 3);
            addReclaimRecipe(new ItemStack(Items.field_151151_aj, 1, OreDictionary.WILDCARD_VALUE), "Gold", 4);
            addReclaimRecipe(new ItemStack(Items.field_151169_ag, 1, OreDictionary.WILDCARD_VALUE), "Gold", 5);
            addReclaimRecipe(new ItemStack(Items.field_151149_ai, 1, OreDictionary.WILDCARD_VALUE), "Gold", 7);
            addReclaimRecipe(new ItemStack(Items.field_151013_M, 1, OreDictionary.WILDCARD_VALUE), "Gold", 2);
            addReclaimRecipe(new ItemStack(Items.field_151005_D, 1, OreDictionary.WILDCARD_VALUE), "Gold", 3);
            addReclaimRecipe(new ItemStack(Items.field_151011_C, 1, OreDictionary.WILDCARD_VALUE), "Gold", 1);
            addReclaimRecipe(new ItemStack(Items.field_151010_B, 1, OreDictionary.WILDCARD_VALUE), "Gold", 2);
            addReclaimRecipe(new ItemStack(Items.field_151097_aZ, 1, OreDictionary.WILDCARD_VALUE), "Iron", 2);

            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 10), new Object[]{new ItemStack(BWMItems.STEEL_HELMET, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 14), new Object[]{new ItemStack(BWMItems.STEEL_CHEST, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 12), new Object[]{new ItemStack(BWMItems.STEEL_PANTS, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 8), new Object[]{new ItemStack(BWMItems.STEEL_BOOTS, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_191525_da, 4), new Object[]{ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.CHAIN_MAIL)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_191525_da, 20), new Object[]{new ItemStack(Items.field_151020_U, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_191525_da, 32), new Object[]{new ItemStack(Items.field_151023_V, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_191525_da, 28), new Object[]{new ItemStack(Items.field_151022_W, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_191525_da, 16), new Object[]{new ItemStack(Items.field_151029_X, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 7), new Object[]{new ItemStack(BWMBlocks.STEEL_ANVIL)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL), new Object[]{ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.ARMOR_PLATE)});
            addStokedCrucibleRecipe(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.INGOT_STEEL, 16), new Object[]{new ItemStack(BWMBlocks.AESTHETIC, 1, 2)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 1), new Object[]{new ItemStack(Items.field_185159_cQ, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 2, 0), new Object[]{new ItemStack(Items.field_151139_aw)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 8, 0), new Object[]{new ItemStack(Items.field_151138_bX, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151043_k, 8, 0), new Object[]{new ItemStack(Items.field_151136_bY, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 5), new Object[]{new ItemStack(Items.field_151143_au)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 5), new Object[]{new ItemStack(Items.field_151108_aI)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 5), new Object[]{new ItemStack(Items.field_151109_aJ)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 5), new Object[]{new ItemStack(Items.field_151140_bW)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 5), new Object[]{new ItemStack(Items.field_151142_bV)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 3), new Object[]{new ItemStack(Blocks.field_150448_aq, 8)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151043_k, 6), new Object[]{new ItemStack(Blocks.field_150318_D, 6)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 6), new Object[]{new ItemStack(Blocks.field_150408_cc, 6)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 3), new Object[]{new ItemStack(Blocks.field_150411_aY, 8)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 7), new Object[]{new ItemStack(Items.field_151066_bu)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 31), new Object[]{new ItemStack(Blocks.field_150467_bQ, 1, OreDictionary.WILDCARD_VALUE)});
            addStokedCrucibleRecipe(new ItemStack(Items.field_151042_j, 5), new Object[]{new ItemStack(Blocks.field_150438_bZ, 1, OreDictionary.WILDCARD_VALUE)});
        }


    }
}
